package com.ruoyi.info.patient.service;

import com.ruoyi.info.patient.domain.Patient;
import com.ruoyi.info.patient.domain.vo.PatientVo;
import com.ruoyi.info.patient.domain.bo.PatientBo;
import com.ruoyi.common.core.page.TableDataInfo;
import com.ruoyi.common.core.domain.PageQuery;

import java.util.Collection;
import java.util.List;

/**
 * 就诊人Service接口
 *
 * @author ruoyi
 * @date 2025-09-20
 */
public interface IPatientService {

    /**
     * 查询就诊人分页
     *
     * @param bo 就诊人
     * @return 就诊人集合
     */
    TableDataInfo<PatientVo> queryPageList(PatientBo bo, PageQuery pageQuery);

    /**
     * 查询就诊人列表
     *
     * @param bo 就诊人
     * @return 就诊人集合
     */
    List<PatientVo> queryList(PatientBo bo);

    /**
     * 查询就诊人
     *
     * @param id 就诊人主键
     * @return 就诊人
     */
    PatientVo queryById(Long id);

    /**
     * 详情就诊人
     *
     * @param id 就诊人主键
     * @return 就诊人
     */
    Patient loadById(Long id, Boolean tw);

    /**
     * 新增就诊人
     *
     * @param bo 就诊人
     * @return 结果
     */
    Boolean insertByBo(PatientBo bo);

    /**
     * 修改就诊人
     *
     * @param bo 就诊人
     * @return 结果
     */
    Boolean updateByBo(PatientBo bo);

    /**
     * 校验并批量删除就诊人信息
     *
     * @param ids 需要删除的就诊人主键集合
     * @param isValid 是否校验,true-删除前校验,false-不校验
     * @return 结果
     */
    Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid);

    void setDefaulted(Long userId, Long patientId);

    PatientVo getDefaulted(Long userId);

    PatientVo queryDelById(Long id);
}
